(*^

::[	Information =

	"This is a Mathematica Notebook file.  It contains ASCII text, and can be
	transferred by email, ftp, or other text-file transfer utility.  It should
	be read or edited using a copy of Mathematica or MathReader.  If you 
	received this as email, use your mail application or copy/paste to save 
	everything from the line containing (*^ down to the line containing ^*)
	into a plain text file.  On some systems you may have to give the file a 
	name ending with ".ma" to allow Mathematica to recognize it as a Notebook.
	The line below identifies what version of Mathematica created this file,
	but it can be opened using any other version as well.";

	FrontEndVersion = "NeXT Mathematica Notebook Front End Version 2.2";

	NeXTStandardFontEncoding; 
	
	fontset = title, inactive, noPageBreakBelow, noPageBreakInGroup, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, L1, e8,  24, "Times"; ;
	fontset = subtitle, inactive, noPageBreakBelow, noPageBreakInGroup, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, L1, e6,  18, "Times"; ;
	fontset = subsubtitle, inactive, noPageBreakBelow, noPageBreakInGroup, nohscroll, preserveAspect, groupLikeTitle, center, M7, italic, L1, e6,  14, "Times"; ;
	fontset = section, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, grayBox, M22, bold, L1, a20,  18, "Times"; ;
	fontset = subsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, blackBox, M19, bold, L1, a15,  14, "Times"; ;
	fontset = subsubsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, whiteBox, M18, bold, L1, a12,  12, "Times"; ;
	fontset = text, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L1,  12;
	fontset = smalltext, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L1,  10, "Times"; ;
	fontset = input, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeInput, M42, N23, bold, L1,  12, "Courier"; ;
	fontset = output, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, L-5,  12, "Courier"; ;
	fontset = message, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, L1,  12, "Courier"; ;
	fontset = print, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, L1,  12, "Courier"; ;
	fontset = info, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, L1,  12, "Courier"; ;
	fontset = postscript, PostScript, formatAsPostScript, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeGraphics, M7, l34, w282, h287, L1,  12, "Courier"; ;
	fontset = name, inactive, noPageBreakInGroup, nohscroll, preserveAspect, M7, italic, B65535, L1,  10, "Times"; ;
	fontset = header, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, italic, L1,  12, "Times"; ;
	fontset = leftheader,  12;
	fontset = footer, inactive, nohscroll, noKeepOnOnePage, preserveAspect, center, M7, italic, L1,  12, "Times"; ;
	fontset = leftfooter,  12;
	fontset = help, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L1,  12;
	fontset = clipboard, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L1,  12;
	fontset = completions, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L1,  12, "Courier"; ;
	fontset = special1, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L1,  12;
	fontset = special2, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L1,  12;
	fontset = special3, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L1,  12;
	fontset = special4, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L1,  12;
	fontset = special5, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L1,  12;
	paletteColors = 128; automaticGrouping; currentKernel; 
]
:[font = input; preserveAspect; startGroup]
<< Numerico.m
<< Numerical.m
:[font = print; inactive; preserveAspect; endGroup]

They have been introduced in  ** NUMERICO.M **           \
 
                         CORounding[a,prec],\
 
  CONorm1[X,n,prec], CONorm2[X,n,prec], CONormi[X,n,prec] 

They have been introduced in  ** NUMERIAL.M **           \
 
                     ALFactor[A,b,n,prec,lu,pi,pp],\
 
  ALCholeski[A,b,n,prec,pp],\
 
  ALFactorwithRefinement[A,b,n,prec,lu,pi,no,tol,pp,pr],\
 
  ALCholeskiwithRefinement[A,b,n,prec,no,tol,pp,pr],\
 
  ALFactorwithnRefinements[A,b,n,prec,lu,pi,nref,pp,pr],\
 
  ALCholeskiwithnRefinements[A,b,n,prec,nref,pp,pr] 
:[font = input; preserveAspect; startGroup]
AL = {{2,1},{4,2.1}}
:[font = output; output; inactive; preserveAspect; endGroup]
{{2, 1}, {4, 2.1}}
;[o]
{{2, 1}, {4, 2.1}}
:[font = input; preserveAspect; startGroup]
AC = {{2,1},{1,2}}
:[font = output; output; inactive; preserveAspect; endGroup]
{{2, 1}, {1, 2}}
;[o]
{{2, 1}, {1, 2}}
:[font = input; preserveAspect; startGroup]
b  = {1.222,3.666}
:[font = output; output; inactive; preserveAspect; endGroup]
{1.222, 3.666}
;[o]
{1.222, 3.666}
:[font = input; preserveAspect; startGroup]
ALFactor[AL,b,2,3,"u","cp","dp"]
:[font = print; inactive; preserveAspect]

For the matrix

[ A | b ] = 2       1       1.222

            4       2.1     3.666

of size  2  that is

[ A | b ] = 2.     1.     1.22

            4.     2.1    3.67

with 3 significant decimal places, the decomposition  L U\
 
    turns out to be

(with partial double precision)

(with diagonal in U and partial pivoting)

P.A =  4.    2.1   L =  1.    0     U =  4.      2.1

       2.    1.         0.5   1.         0       -0.05

with permutation of rows

P =  {2, 1}

and the solution is

X =  {-5.58, 12.4}

:[font = output; output; inactive; preserveAspect; endGroup]
"LU.DAT"
;[o]
LU.DAT
:[font = input; preserveAspect; startGroup]
ALCholeski[AC,b,2,3,"dp"]
:[font = print; inactive; preserveAspect]

For the matrix

[ A | b ] = 2       1       1.222

            1       2       3.666

of size  2  that is

[ A | b ] = 2.     1.     1.22

            1.     2.     3.67

with 3 significant decimal places, the matrix  L  of A =\
 
   L.tL turns out to be

(with partial double precision)

L =  1.41    0

     0.709   1.22

and the solution is

X =  {-0.422, 2.06}

:[font = output; output; inactive; preserveAspect; endGroup]
"CH.DAT"
;[o]
CH.DAT
:[font = input; preserveAspect; startGroup]
ALFactorwithRefinement[AL,b,2,3,"u","sp","ni",0.01,"dp","dr"]
:[font = print; inactive; preserveAspect]

For the matrix

[ A | b ] = 2       1       1.222

            4       2.1     3.666

of size  2  that is

[ A | b ] = 2.     1.     1.22

            4.     2.1    3.67

with 3 significant decimal places, the decomposition  L U\
 
    turns out to be

(with partial double precision)

(with diagonal in U and without pivoting)

A =  2.    1.    L =  1.   0    U =  2.    1.

     4.    2.1        2.   1.        0     0.1

and the refined solution is

X =  {-5.54, 12.3}

with refinements

XR = -5.55   12.3

     -5.54   12.3

(the refinement with double precision)

:[font = output; output; inactive; preserveAspect; endGroup]
"LR.DAT"
;[o]
LR.DAT
:[font = input; preserveAspect; startGroup]
ALCholeskiwithRefinement[AC,b,2,3,"n1",0.01,"sp","dr"]
:[font = print; inactive; preserveAspect]

For the matrix

[ A | b ] = 2       1       1.222

            1       2       3.666

of size  2  that is

[ A | b ] = 2.     1.     1.22

            1.     2.     3.67

with 3 significant decimal places, the matrix  L  of A =\
 
   L.tL turns out to be

L =  1.41    0

     0.709   1.22

and the refined solution is

X =  {-0.41, 2.04}

with refinements

XR = -0.422   2.06

     -0.41    2.04

     -0.41    2.04

(the refinement with double precision)

:[font = output; output; inactive; preserveAspect; endGroup]
"CR.DAT"
;[o]
CR.DAT
:[font = input; preserveAspect; startGroup]
ALFactorwithnRefinements[AL,b,2,3,"u","sp",3,"dp","sr"]
:[font = print; inactive; preserveAspect]

For the matrix

[ A | b ] = 2       1       1.222

            4       2.1     3.666

of size  2  that is

[ A | b ] = 2.     1.     1.22

            4.     2.1    3.67

with 3 significant decimal places, the decomposition  L U\
 
    turns out to be

(with partial double precision)

(with diagonal in U and without pivoting)

A =  2.    1.    L =  1.   0    U =  2.    1.

     4.    2.1        2.   1.        0     0.1

and the refined solution is

X =  {-4.97, 11.2}

with refinements

XR = -5.55   12.3

     -5.69   12.6

     -5.33   11.9

     -4.97   11.2

:[font = output; output; inactive; preserveAspect; endGroup]
"LN.DAT"
;[o]
LN.DAT
:[font = input; preserveAspect; startGroup]
ALCholeskiwithnRefinements[AC,b,2,3,3,"sp","sr"]
:[font = print; inactive; preserveAspect]

For the matrix

[ A | b ] = 2       1       1.222

            1       2       3.666

of size  2  that is

[ A | b ] = 2.     1.     1.22

            1.     2.     3.67

with 3 significant decimal places, the matrix  L  of A =\
 
   L.tL turns out to be

L =  1.41    0

     0.709   1.22

and the refined solution is

X =  {-0.412, 2.04}

with refinements

XR = -0.422   2.06

     -0.412   2.04

     -0.412   2.04

     -0.412   2.04

:[font = output; output; inactive; preserveAspect; endGroup]
"CN.DAT"
;[o]
CN.DAT
^*)
